#!/usr/bin/perl
# dig_subs.pl (/home/majordom/applications)
# Created:      Wed Jul  2 08:53:07 PDT 1997
# Last updated: Wed Apr 19 18:01:45 GMT 2000

sub modify_config{
    open(IT,"${listpath}.config") || die "couldn't open list config, dying\n";
    open(NEW,">${listpath}-digest.config") || die "couldn't open digest config\n";
    while(<IT>){
	($key)=/^(\w+)\s+/;
	if($key eq 'digest_name'){
	    print NEW "digest_name = $digest\n";
	}
	elsif($key eq 'sender'){
	    print NEW "sender = owner-$digest\n";
	}
	elsif($key eq 'subscribe_policy'){
	    print NEW "subscribe_policy = $list_subs\n";
	}
	elsif($key eq 'message_fronter'){
	    print NEW $_;
	    print NEW "_SUBJECTS_\n";
	}
	else {print NEW $_;}
    }
    close(IT);
    close(NEW);
}

sub get_list_alias{
    my($alias,$forw);
    $alias="${list}-outgoing";
#    open(ALIASES,"/etc/aliases") || debug_message("couldn't open /etc/aliases. dying");
    open(ALIASES,"$ENV{'HOME'}/aliases.majordomo") || die "couldn't open /home/majordom/aliases.majordomo. dying\n";
    while(<ALIASES>){
	chop;
	next unless /^${alias}:(.+)$/;
	$forw=$1,last;
    }
    close(ALIASES);
    $forw;
}

sub create_aliases{
    my($add)="\"$wrapper digest -r -C -l $digest ${digest}-outgoing\"";
    my($list_alias);
    ($list_alias=&get_list_alias) || die "couldn't get list alias, dying\n";
    $|=1;			# flush output
    $list_alias=join(',',$list_alias,$add);
    $aliases="${digest}.aliases";
    print STDOUT $aliases,`pwd`;
    open(FILE,">$aliases") || die "couldn't open $aliases, dying\n";
    print FILE "Subject: darkwing aliases request for majordomo\n";
    print FILE "\nPlease change ${list}-outgoing to:\n";
    print FILE "$list_alias\n";
    print FILE "\n\nPlease add the following:\n";
    print FILE "# $digest mailing list aliases (majordomo on darkwing)\n";
    print FILE "$digest: $list\n";
    print FILE "${digest}-outgoing: :include:${listpath}-digest\n";
    print FILE "${digest}-request: owner-$list\n";
    print FILE "owner-$digest: owner-$list\n";
    print FILE "owner-$digest-outgoing: owner-$list\n";
    print FILE "owner-$digest-request: owner-$list\n";
    print FILE "${digest}-approval: ${list}-approval\n";
    close(FILE);
}

sub create_dirs{
    unless(-d "${filedir}/$digest"){ # create archive directory
	mkdir("${filedir}/$digest",0775) ||
	    die "couldn't mkdir ${filedir}/$digest, dying\n";
    }
    unless(-d "${digest_work_dir}/$digest"){	# create digest directory
	mkdir("${digest_work_dir}/$digest",0775) ||
	    die "couldn't mkdir ${digest_work_dir}/$digest, dying\n";
    }
}

sub create_info{
    open(LIST,">${listpath}-digest.info") || die "couldn't open info, dying\n";
    print LIST "Welcome to $digest, the digest for $list\n";
    print LIST "Questions about the administration of this list ",
            "should be addressed to\n${list}-owner\@$mdhost\n\n";
    print LIST "To unsubscribe from this list send a message to\n",
      "majordomo\@$mdhost with the contents:\n\n",
      "  unsubscribe $list-digest\n  end\n\n";
    close(LIST);
}

sub create_digest_file{
    my($listfile)="$listdir/${digest}.pending"; # hide it for "listlists"
    open(LIST,">$listfile")
        || die "couldn't create $listfile, dying\n";
    print LIST "# list of addresses for $digest\n";
    print LIST "owner-${list}\n"; # need at least one address or it fails :-(
    close(LIST);
    chmod 0664,$listfile;
}

sub get_dig_args{
    my(%legal)=(owner=>1,full_name=>1,description=>1,initial_list=>1,
                replies_to=>1,phone=>1,list_subs=>1,dept=>1,password=>1,
                camp_addr=>1,listname=>1,welcome=>1,list_type=>1,
		service=>2,query=>2);
    my($key,$val,$code);
    open(FORM,"-")|| die "open of - (STDIN) failed, dying\n";
    while(<FORM>){last if /^begin_data/;} # skip to real data
    while(<FORM>){
        chop;
        ($key,$val)=split(/:/);
        last if $key eq 'end_data';
        if($key){
            if($code=$legal{$key}){
		if($code==1){$$key=$val;} # use key as variable name (perl5)
		elsif($code==2){next;} # known but not useful
		else{ die "illegal key: $_, dying\n";}
	    }
        }
    }
    $listname;
}

sub right_password {
    my($tag,$config,$rightpass);
    $config="$listdir/${listname}.config";
    unless(open(CONFIG,$config)){
        &debug_message("can't open $config for CONFIG",$FORM{'password'});
        exit;
    }
    else{
        while(<CONFIG>){
            chop;
            last if /^admin_passwd/;
        }
        close(CONFIG);
        ($tag,$rightpass)=split(/=\s*/);
        $password eq $rightpass;
    }
}

sub debug_message{
    print DEBUG join(',',@_),"\n";
    print STDOUT join(',',@_),"\n";
    close STDOUT;
}

sub create_dig_owner_info{
    my($info)="$base/${digest}-owner-info";
    open(NEW,">$info")|| print DEBUG "couldn't open $info\n";;
    print NEW "Subject: $digest ready to go\n";
    print NEW "Bcc: $me\n\n";
    print NEW "Your digest, $digest, is ready to go.\n";
    print NEW "The list password is the same as the list itself\n";
    print NEW "To trigger an issue send the following to majordomo\@$mdhost:\n\n";
    print NEW " mkdigest $digest PASSWORD\n end\n";
    print NEW "To see a list of past issues send\n\n";
    print NEW " index $digest\n end\n\n";
    close(NEW);
    chmod 0600,"$info";
}
1;


